#TEMPLATE (CBAltFix, 'Carl Barnes fix for Alt Key Lockup in Windows 7'),FAMILY('ABC','CW20')
#!===========================================================================
#EXTENSION (AltWin7Fix_Global,'Fix Windows 7 Alt Key Lockup-Global-by Carl Barnes'), APPLICATION
  #BOXED('')
    #DISPLAY('Clarion MDI Apps built by C6, C5.5, C5, or C4 will lockup')
    #DISPLAY('under Windows 7 if ALT is pressed and released, or the')
    #DISPLAY('F10 key, in an MDI Child Window.')
    #DISPLAY('Read Clarion Magazine: A Windows 7 Alt-Lockup Fix')
#!      #DISPLAY('This normally would active the Menubar.')
    #DISPLAY('')
    #PROMPT('Fix Windows 7 Alt Key Bug',CHECK),%FixAltKeyBug,DEFAULT(1),AT(6)
    #ENABLE(%FixAltKeyBug)
    #DISPLAY('On ALT key release this drops the first menu by sending')
    #DISPLAY('an Alt+ letter message to the menu. This normally')
    #DISPLAY('would be "f" when MENU(''&File'') is first menu.')
    #PROMPT('ALT+ &&letter of 1st Menu',@S1),%FirstMenuLetter,DEFAULT('f')
    #ENDENABLE
    #DISPLAY('')
    #PROMPT('Auto Close App during Windows Shutdown',CHECK),%AutoShutdown,AT(6)
    #ENABLE(%AutoShutdown)
    #DISPLAY('Template will take WM_QUERYENDSESSION message')
    #DISPLAY('and close app during Windows shutdown.')
    #ENDENABLE
    #DISPLAY('')
    #DISPLAY('Instructions:')
    #DISPLAY('1. Add AltWin7Fix_Global (in .APP with Frame)')
    #DISPLAY('2. Set your 1st Menu Key above')        
    #DISPLAY('3. Open the Frame procedure')        
    #DISPLAY('4. Add Extension template: AltWin7Fix_Frame')
    #DISPLAY('5. Recompile the App and Test')
  #ENDBOXED
  #DISPLAY('(c)2011 Carl Barnes, Barrington Illinois')
  #DISPLAY('Free for use by Clarion Magazine Subscribers')
#AT(%GlobalData)
W7AF_AppFrame_OrigWndProc   LONG    !Win7AltFix Frame WndProc for W7AF_CallWindowProc
#ENDAT
#AT(%GlobalMap)
 W7AF_SubClassFrame(SIGNED _hWnd, UNSIGNED _wMsg, UNSIGNED _wParam, SIGNED _LParam),SIGNED,PASCAL !Win7AltFix
 MODULE('Win32') !Win7AltFix
  W7AF_CallWindowProc(SIGNED lpPrevWndProc,UNSIGNED hWnd,UNSIGNED wMsg,UNSIGNED wParam,SIGNED lParam),SIGNED,RAW,PASCAL,DLL(1),NAME('CallWindowProcA')
  W7AF_PostMessage(UNSIGNED hWnd,UNSIGNED uMsg,UNSIGNED wParam,LONG lParam),BOOL,PASCAL,PROC,DLL(1),NAME('PostMessageA')
 END
#ENDAT
#!---------
#AT(%ProgramRoutines)
W7AF_SubClassFrame  PROCEDURE(SIGNED _hWnd, UNSIGNED _wMsg, UNSIGNED _wParam, SIGNED _LParam)!,SIGNED,PASCAL !Win7AltFix
!WM_SYSCOMMAND       EQUATE(0112h)       !WM_SYSCOMMAND 0x0112   !Win7AltFix
!SC_KEYMENU          EQUATE(0F100h)      !SC_KEYMENU 0xF100      !Win7AltFix
!SC_AndMask         EQUATE(0FFF0h)      !WM_SYSCOMMAND msgs the 4 low-order bits of wParam are used internally, you must strip lower 4 bits to compare to SC_xxx
#IF (~%FirstMenuLetter)
Alt1stMenu          EQUATE(val('f')) !<<< set to your first menu Alt letter, i.e. &File is Alt+f (use lower case)
#ELSE
Alt1stMenu          EQUATE(val('%(LOWER(%FirstMenuLetter))')) !<<< set to your first menu Alt letter, i.e. &File is Alt+f (use lower case)
#ENDIF
#EMBED(%W7AFSubClassFrameDataSection,'Alt7 Fix Frame Subclass Data Section'),DATA
  CODE
  #EMBED(%W7AFSubClassFrameCodeTop,'Alt7 Fix Frame Subclass Code before CASE _wMsg')
    CASE _wMsg
  #EMBED(%W7AFSubClassFrameCodeCasewMsg,'Alt7 Fix Frame Subclass Code inside CASE _wMsg')
#IF (%FixAltKeyBug)
    OF 0112h !WM_SYSCOMMAND
       IF BAND(_wParam,0FFF0h)=0F100h |                     !Win7AltFix _wParam=SC_KEYMENU ?  (striped of 0Fh bits)
       AND _LParam=0 THEN                                   !Win7AltFix _LParam=menu key, 0=ALT or F10
           W7AF_PostMessage(_hWnd,0112h,0F100h, Alt1stMenu) !Win7AltFix  Send WM_SYSCOMMAND,SC_KEYMENU,Alt+F Menu message to drop file menu
           RETURN(True)                                     !Win7AltFix  Prevent RTL from getting message or locks up frame
       END
#ENDIF
#IF (%AutoShutdown)
        OF 0011h ; RETURN(True)  !WM_QUERYENDSESSION  EQUATE(0011h) Windows is asking if we would shutdown, we say YES
        OF 0016h ; RETURN(True)  !WM_ENDSESSION       EQUATE(0016h) Windows IS shutting down, we say YES and will get EVENT:CloseDown next
#ENDIF
    END  !CASE _wMsg
  #EMBED(%W7AFSubClassFrameCodeEnd,'Alt7 Fix Frame Subclass Code before Return')
    RETURN(W7AF_CallWindowProc(W7AF_AppFrame_OrigWndProc,_hWnd,_wMsg,_wParam,_LParam))  !Win7AltFix 
#ENDAT
#!===========================================================================
#EXTENSION(AltWin7Fix_Frame,'Fix Windows 7 Alt Key Lockup-Frame Extension-by Carl Barnes'),PROCEDURE,FIRST,REQ(AltWin7Fix_Global)
  #RESTRICT
    #CASE(%ProcedureTemplate)
    #OF('Frame')
    #OROF('FRAME')
      #ACCEPT
    #ELSE
      #REJECT
    #ENDCASE
  #ENDRESTRICT
#BOXED('')
#DISPLAY('When Alt is released this activates the first menu')
#DISPLAY('by sending the Alt+ letter to the menu. This normally')
#DISPLAY('would be "f" based on MENU(&File).')
#DISPLAY('')
#DISPLAY('In the Global Alt Fix Extension you MUST define the')
#DISPLAY('the first Menu letter e.g. "f".')
#DISPLAY('')
#DISPLAY('This extension sets Frame Prop:WndProc to point to')
#DISPLAY('subclass procedure W7AF_AppFrame_OrigWndProc.')
#DISPLAY('That procedure is in the root module and has embeds')
#DISPLAY('available under Global.')
#DISPLAY('')
#ENDBOXED
#DISPLAY('(c)2011 Carl Barnes, Barrington Illinois')
#DISPLAY('Free for use by Clarion Magazine Subscribers')
#AT(%AfterWindowOpening)
    !Subclass sends messages to W7AF_SubClassFrame() procedure in Global. Fix Alt 7 lockup.
    !%ProcedureTemplate 
    W7AF_AppFrame_OrigWndProc   = %window{PROP:WndProc}  !Win7AltFix
    %window{PROP:WndProc} = Address(W7AF_SubClassFrame)  !Win7AltFix
#ENDAT
