

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL015.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('SCHOOL013.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('SCHOOL016.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Update the Majors File
!!! </summary>
UpdateMajors PROCEDURE 

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
OriginalRequest      LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
WindowInitialized    LONG                                  !
ForceRefresh         LONG                                  !
RecordFiltered       LONG                                  !
ActionMessage        CSTRING(40)                           !
RecordChanged        BYTE,AUTO                             !
BRW2::View:Browse    VIEW(Teachers)
                       PROJECT(TEA:FirstName)
                       PROJECT(TEA:LastName)
                       PROJECT(TEA:Address)
                       PROJECT(TEA:City)
                       PROJECT(TEA:State)
                       PROJECT(TEA:Zip)
                       PROJECT(TEA:Telephone)
                       PROJECT(TEA:Number)
                       PROJECT(TEA:Department)
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
TEA:FirstName          LIKE(TEA:FirstName)            !List box control field - type derived from field
TEA:LastName           LIKE(TEA:LastName)             !List box control field - type derived from field
TEA:Address            LIKE(TEA:Address)              !List box control field - type derived from field
TEA:City               LIKE(TEA:City)                 !List box control field - type derived from field
TEA:State              LIKE(TEA:State)                !List box control field - type derived from field
TEA:Zip                LIKE(TEA:Zip)                  !List box control field - type derived from field
TEA:Telephone          LIKE(TEA:Telephone)            !List box control field - type derived from field
TEA:Number             LIKE(TEA:Number)               !Primary key field - type derived from field
TEA:Department         LIKE(TEA:Department)           !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW4::View:Browse    VIEW(Students)
                       PROJECT(STU:FirstName)
                       PROJECT(STU:LastName)
                       PROJECT(STU:Address)
                       PROJECT(STU:Address2)
                       PROJECT(STU:City)
                       PROJECT(STU:State)
                       PROJECT(STU:Zip)
                       PROJECT(STU:Telephone)
                       PROJECT(STU:GradYear)
                       PROJECT(STU:Number)
                       PROJECT(STU:Major)
                     END
Queue:Browse:4       QUEUE                            !Queue declaration for browse/combo box using ?Browse:4
STU:FirstName          LIKE(STU:FirstName)            !List box control field - type derived from field
STU:LastName           LIKE(STU:LastName)             !List box control field - type derived from field
STU:Address            LIKE(STU:Address)              !List box control field - type derived from field
STU:Address2           LIKE(STU:Address2)             !List box control field - type derived from field
STU:City               LIKE(STU:City)                 !List box control field - type derived from field
STU:State              LIKE(STU:State)                !List box control field - type derived from field
STU:Zip                LIKE(STU:Zip)                  !List box control field - type derived from field
STU:Telephone          LIKE(STU:Telephone)            !List box control field - type derived from field
STU:GradYear           LIKE(STU:GradYear)             !List box control field - type derived from field
STU:Number             LIKE(STU:Number)               !Primary key field - type derived from field
STU:Major              LIKE(STU:Major)                !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::MAJ:Record  LIKE(MAJ:RECORD),THREAD
QuickWindow          WINDOW('Update the Majors File'),AT(,,159,138),FONT('MS Sans Serif',8,COLOR:Black),GRAY,IMM, |
  MDI,HLP('~UpdateMajors'),SYSTEM
                       SHEET,AT(4,4,151,112),USE(?CurrentTab)
                         TAB('General'),USE(?TAB1)
                           PROMPT('&Description:'),AT(8,20),USE(?MAJ:Description:Prompt),TRN
                           ENTRY(@S20),AT(64,20,84,10),USE(MAJ:Description)
                         END
                         TAB('Teachers'),USE(?TeachersTab)
                           LIST,AT(8,20,143,94),USE(?Browse:2),HVSCROLL,FORMAT('80L(2)|M~First Name~L(2)@S20@80L(2' & |
  ')|M~Last Name~L(2)@S20@80L(2)|M~Address~L(2)@S20@80L(2)|M~City~L(2)@S20@24L(2)|M~Sta' & |
  'te~L(2)@S2@24R(2)|M~Zip~C(0)@n05@52L(2)|M~Telephone~L(2)@s12@'),FROM(Queue:Browse:2),IMM, |
  MSG('Browsing Records')
                           BUTTON('&Insert'),AT(8,98,45,14),USE(?Insert:3),HIDE
                           BUTTON('&Change'),AT(57,98,45,14),USE(?Change:3),HIDE
                           BUTTON('&Delete'),AT(106,98,45,14),USE(?Delete:3),HIDE
                         END
                         TAB('Students'),USE(?StudentsTab)
                           LIST,AT(8,20,143,94),USE(?Browse:4),HVSCROLL,FORMAT('80L(2)|M~First Name~L(2)@S20@80L(2' & |
  ')|M~Last Name~L(2)@S20@80L(2)|M~Address~L(2)@S20@80L(2)|M~Address 2~L(2)@s20@80L(2)|' & |
  'M~City~L(2)@S20@24L(2)|M~State~L(2)@S2@24R(2)|M~Zip~C(0)@n05@52L(2)|M~Telephone~L(2)' & |
  '@s12@40R(2)|M~Grad Year~C(0)@n4@'),FROM(Queue:Browse:4),IMM,MSG('Browsing Records')
                           BUTTON('&Insert'),AT(8,98,45,14),USE(?Insert:5),HIDE
                           BUTTON('&Change'),AT(57,98,45,14),USE(?Change:5),HIDE
                           BUTTON('&Delete'),AT(106,98,45,14),USE(?Delete:5),HIDE
                         END
                       END
                       BUTTON('OK'),AT(12,120,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(61,120,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(110,120,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)                    ! Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW2::Sort0:StepClass StepLongClass                        ! Default Step Manager
BRW4                 CLASS(BrowseClass)                    ! Browse using ?Browse:4
Q                      &Queue:Browse:4                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW4::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW4::Sort0:StepClass StepStringClass                      ! Default Step Manager
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Majors Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Majors Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateMajors')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?MAJ:Description:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(MAJ:Record,History::MAJ:Record)
  SELF.AddHistoryField(?MAJ:Description,2)
  SELF.AddUpdateFile(Access:Majors)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Majors.SetOpenRelated()
  Relate:Majors.Open                                       ! File Majors used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Majors
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Teachers,SELF) ! Initialize the browse manager
  BRW4.Init(?Browse:4,Queue:Browse:4.ViewPosition,BRW4::View:Browse,Queue:Browse:4,Relate:Students,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon TEA:Department for sort order 1
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,TEA:KeyDepartment) ! Add the sort order for TEA:KeyDepartment for sort order 1
  BRW2.AddRange(TEA:Department,Relate:Teachers,Relate:Majors) ! Add file relationship range limit for sort order 1
  BRW2.AddField(TEA:FirstName,BRW2.Q.TEA:FirstName)        ! Field TEA:FirstName is a hot field or requires assignment from browse
  BRW2.AddField(TEA:LastName,BRW2.Q.TEA:LastName)          ! Field TEA:LastName is a hot field or requires assignment from browse
  BRW2.AddField(TEA:Address,BRW2.Q.TEA:Address)            ! Field TEA:Address is a hot field or requires assignment from browse
  BRW2.AddField(TEA:City,BRW2.Q.TEA:City)                  ! Field TEA:City is a hot field or requires assignment from browse
  BRW2.AddField(TEA:State,BRW2.Q.TEA:State)                ! Field TEA:State is a hot field or requires assignment from browse
  BRW2.AddField(TEA:Zip,BRW2.Q.TEA:Zip)                    ! Field TEA:Zip is a hot field or requires assignment from browse
  BRW2.AddField(TEA:Telephone,BRW2.Q.TEA:Telephone)        ! Field TEA:Telephone is a hot field or requires assignment from browse
  BRW2.AddField(TEA:Number,BRW2.Q.TEA:Number)              ! Field TEA:Number is a hot field or requires assignment from browse
  BRW2.AddField(TEA:Department,BRW2.Q.TEA:Department)      ! Field TEA:Department is a hot field or requires assignment from browse
  BRW4.Q &= Queue:Browse:4
  BRW4::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon STU:LastName for sort order 1
  BRW4.AddSortOrder(BRW4::Sort0:StepClass,STU:MajorKey)    ! Add the sort order for STU:MajorKey for sort order 1
  BRW4.AddRange(STU:Major,Relate:Students,Relate:Majors)   ! Add file relationship range limit for sort order 1
  BRW4.AddLocator(BRW4::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW4::Sort0:Locator.Init(,STU:LastName,1,BRW4)           ! Initialize the browse locator using  using key: STU:MajorKey , STU:LastName
  BRW4.AddField(STU:FirstName,BRW4.Q.STU:FirstName)        ! Field STU:FirstName is a hot field or requires assignment from browse
  BRW4.AddField(STU:LastName,BRW4.Q.STU:LastName)          ! Field STU:LastName is a hot field or requires assignment from browse
  BRW4.AddField(STU:Address,BRW4.Q.STU:Address)            ! Field STU:Address is a hot field or requires assignment from browse
  BRW4.AddField(STU:Address2,BRW4.Q.STU:Address2)          ! Field STU:Address2 is a hot field or requires assignment from browse
  BRW4.AddField(STU:City,BRW4.Q.STU:City)                  ! Field STU:City is a hot field or requires assignment from browse
  BRW4.AddField(STU:State,BRW4.Q.STU:State)                ! Field STU:State is a hot field or requires assignment from browse
  BRW4.AddField(STU:Zip,BRW4.Q.STU:Zip)                    ! Field STU:Zip is a hot field or requires assignment from browse
  BRW4.AddField(STU:Telephone,BRW4.Q.STU:Telephone)        ! Field STU:Telephone is a hot field or requires assignment from browse
  BRW4.AddField(STU:GradYear,BRW4.Q.STU:GradYear)          ! Field STU:GradYear is a hot field or requires assignment from browse
  BRW4.AddField(STU:Number,BRW4.Q.STU:Number)              ! Field STU:Number is a hot field or requires assignment from browse
  BRW4.AddField(STU:Major,BRW4.Q.STU:Major)                ! Field STU:Major is a hot field or requires assignment from browse
  BRW2.AskProcedure = 1
  BRW4.AskProcedure = 2
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW2.ToolbarItem.HelpButton = ?Help
  BRW4.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW4.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Majors.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      UpdateTeachers
      UpdateStudents
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


BRW4.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:5
    SELF.ChangeControl=?Change:5
    SELF.DeleteControl=?Delete:5
  END

