

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL016.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('SCHOOL002.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('SCHOOL014.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Update the Students File
!!! </summary>
UpdateStudents PROCEDURE 

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
OriginalRequest      LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
WindowInitialized    LONG                                  !
ForceRefresh         LONG                                  !
RecordFiltered       LONG                                  !
ActionMessage        CSTRING(40)                           !
RecordChanged        BYTE,AUTO                             !
DOSDialogHeader      CSTRING(40)                           !
DOSExtParameter      CSTRING(250)                          !
DOSTargetVariable    CSTRING(80)                           !
SelectMajorsThread   LONG                                  !
PhotoChanged         BYTE                                  !
BRW2::View:Browse    VIEW(Enrollment)
                       PROJECT(ENR:ClassNumber)
                       PROJECT(ENR:MidtermExam)
                       PROJECT(ENR:FinalExam)
                       PROJECT(ENR:TermPaper)
                       PROJECT(ENR:StudentNumber)
                       JOIN(CLA:KeyClassNumber,ENR:ClassNumber)
                         PROJECT(CLA:ScheduledTime)
                         PROJECT(CLA:ClassNumber)
                         PROJECT(CLA:CourseNumber)
                         JOIN(COU:KeyNumber,CLA:CourseNumber)
                           PROJECT(COU:Description)
                           PROJECT(COU:Number)
                         END
                       END
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
ENR:ClassNumber        LIKE(ENR:ClassNumber)          !List box control field - type derived from field
CLA:ScheduledTime      LIKE(CLA:ScheduledTime)        !List box control field - type derived from field
COU:Description        LIKE(COU:Description)          !List box control field - type derived from field
ENR:MidtermExam        LIKE(ENR:MidtermExam)          !List box control field - type derived from field
ENR:FinalExam          LIKE(ENR:FinalExam)            !List box control field - type derived from field
ENR:TermPaper          LIKE(ENR:TermPaper)            !List box control field - type derived from field
ENR:StudentNumber      LIKE(ENR:StudentNumber)        !Browse key field - type derived from field
CLA:ClassNumber        LIKE(CLA:ClassNumber)          !Related join file key field - type derived from field
COU:Number             LIKE(COU:Number)               !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::STU:Record  LIKE(STU:RECORD),THREAD
QuickWindow          WINDOW('Update the Students File'),AT(,,303,204),FONT('MS Sans Serif',8,COLOR:Black),RESIZE, |
  GRAY,IMM,MDI,HLP('~UpdateStudents'),PALETTE(256),SYSTEM
                       SHEET,AT(3,4,298,173),USE(?CurrentTab)
                         TAB('General'),USE(?TAB1)
                           PROMPT('&First Name:'),AT(7,20),USE(?STU:FirstName:Prompt),TRN
                           ENTRY(@S20),AT(47,20,84,10),USE(STU:FirstName)
                           PROMPT('&Last Name:'),AT(7,34),USE(?STU:LastName:Prompt),TRN
                           ENTRY(@S20),AT(47,34,84,10),USE(STU:LastName)
                           PROMPT('&Address:'),AT(7,48),USE(?STU:Address:Prompt),TRN
                           ENTRY(@S20),AT(47,48,84,10),USE(STU:Address)
                           PROMPT('Address 2:'),AT(7,62),USE(?STU:Address2:Prompt),TRN
                           ENTRY(@s20),AT(47,62,84,10),USE(STU:Address2)
                           PROMPT('&City:'),AT(7,76),USE(?STU:City:Prompt),TRN
                           ENTRY(@S20),AT(47,76,84,10),USE(STU:City)
                           PROMPT('&State:'),AT(7,90),USE(?STU:State:Prompt),TRN
                           ENTRY(@S2),AT(47,90,40,10),USE(STU:State)
                           PROMPT('&Zip:'),AT(7,104),USE(?STU:Zip:Prompt),TRN
                           ENTRY(@n05),AT(47,104,40,10),USE(STU:Zip)
                           PROMPT('&Telephone:'),AT(7,118),USE(?STU:Telephone:Prompt),TRN
                           ENTRY(@s12),AT(47,118,52,10),USE(STU:Telephone)
                           PROMPT('Grad Year:'),AT(7,132),USE(?STU:GradYear:Prompt),TRN
                           ENTRY(@n4),AT(47,132,40,10),USE(STU:GradYear)
                           PROMPT('&Number:'),AT(7,146),USE(?STU:Number:Prompt),TRN
                           ENTRY(@P###-##-####P),AT(47,146,,10),USE(STU:Number),RIGHT(1),REQ
                           STRING(@s20),AT(74,160,77,10),USE(MAJ:Description),TRN
                           PROMPT('Major:'),AT(7,160),USE(?STU:Major:Prompt),TRN
                           ENTRY(@n4),AT(47,160,13,10),USE(STU:Major),ALRT(F10Key),DROPID('Majors')
                           BUTTON('...'),AT(61,159,12,12),USE(?Button8)
                         END
                         TAB('Enrollment'),USE(?EnrollmentTab)
                           LIST,AT(7,22,290,148),USE(?Browse:2),HVSCROLL,FORMAT('[52L(2)|M~Class Number~@p##-#####' & |
  'p@80L(2)|M~Scheduled Time~@s20@/120L(2)|M~Description~@S30@]|M~Class~[52R(2)|M~Midte' & |
  'rm Exam~C(0)@n3@44R(2)|M~Final Exam~C(0)@n3@44R(2)|M~Term Paper~C(0)@n3@]|M~Grades~'),FROM(Queue:Browse:2), |
  IMM,MSG('Browsing Records')
                           BUTTON('&Insert'),AT(7,128,45,14),USE(?Insert:3),HIDE
                           BUTTON('&Change'),AT(57,128,45,14),USE(?Change:3),HIDE
                           BUTTON('&Delete'),AT(105,128,45,14),USE(?Delete:3),HIDE
                         END
                         TAB('Photo'),USE(?Tab3)
                           IMAGE,AT(8,24),USE(?Image1)
                           ENTRY(@s64),AT(7,158,129,12),USE(GLO:FileName)
                           PROMPT('Image File Name:'),AT(7,147),USE(?GLO:FileName:Prompt),TRN
                           BUTTON('...'),AT(137,158,12,12),USE(?LookupFile)
                         END
                       END
                       BUTTON('OK'),AT(12,185,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(61,185,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(110,185,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeCompleted          PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)                    ! Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW2::Sort0:StepClass StepLongClass                        ! Default Step Manager
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
FileLookup6          SelectFileClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
!Display photo maintaining aspect ratio
DisplayImage  ROUTINE
  IF ?Image1{PROP:Height} > 100
    AspectRatio$ = ?Image1{PROP:Width}/?Image1{PROP:Height}
    ?Image1{PROP:Height} = 100
    ?Image1{PROP:Width} = 100 * AspectRatio$
  END
  IF ?Image1{PROP:Width} > 100
    AspectRatio$ = ?Image1{PROP:Height}/?Image1{PROP:Width}
    ?Image1{PROP:Width} = 100
    ?Image1{PROP:Height} = 100 * AspectRatio$
  END

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Students Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Students Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateStudents')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?STU:FirstName:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(STU:Record,History::STU:Record)
  SELF.AddHistoryField(?STU:FirstName,3)
  SELF.AddHistoryField(?STU:LastName,4)
  SELF.AddHistoryField(?STU:Address,5)
  SELF.AddHistoryField(?STU:Address2,6)
  SELF.AddHistoryField(?STU:City,7)
  SELF.AddHistoryField(?STU:State,8)
  SELF.AddHistoryField(?STU:Zip,9)
  SELF.AddHistoryField(?STU:Telephone,10)
  SELF.AddHistoryField(?STU:GradYear,12)
  SELF.AddHistoryField(?STU:Number,2)
  SELF.AddHistoryField(?STU:Major,11)
  SELF.AddUpdateFile(Access:Students)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Enrollment.SetOpenRelated()
  Relate:Enrollment.Open                                   ! File Enrollment used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Students
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Enrollment,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon ENR:ClassNumber for sort order 1
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,ENR:StuSeq)      ! Add the sort order for ENR:StuSeq for sort order 1
  BRW2.AddRange(ENR:StudentNumber,Relate:Enrollment,Relate:Students) ! Add file relationship range limit for sort order 1
  BRW2.AddField(ENR:ClassNumber,BRW2.Q.ENR:ClassNumber)    ! Field ENR:ClassNumber is a hot field or requires assignment from browse
  BRW2.AddField(CLA:ScheduledTime,BRW2.Q.CLA:ScheduledTime) ! Field CLA:ScheduledTime is a hot field or requires assignment from browse
  BRW2.AddField(COU:Description,BRW2.Q.COU:Description)    ! Field COU:Description is a hot field or requires assignment from browse
  BRW2.AddField(ENR:MidtermExam,BRW2.Q.ENR:MidtermExam)    ! Field ENR:MidtermExam is a hot field or requires assignment from browse
  BRW2.AddField(ENR:FinalExam,BRW2.Q.ENR:FinalExam)        ! Field ENR:FinalExam is a hot field or requires assignment from browse
  BRW2.AddField(ENR:TermPaper,BRW2.Q.ENR:TermPaper)        ! Field ENR:TermPaper is a hot field or requires assignment from browse
  BRW2.AddField(ENR:StudentNumber,BRW2.Q.ENR:StudentNumber) ! Field ENR:StudentNumber is a hot field or requires assignment from browse
  BRW2.AddField(CLA:ClassNumber,BRW2.Q.CLA:ClassNumber)    ! Field CLA:ClassNumber is a hot field or requires assignment from browse
  BRW2.AddField(COU:Number,BRW2.Q.COU:Number)              ! Field COU:Number is a hot field or requires assignment from browse
  QuickWindow{PROP:MinWidth} = 160                         ! Restrict the minimum window width
  QuickWindow{PROP:MinHeight} = 204                        ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  !Display photo from stored BLOB
  ?Image1{PROP:NoWidth} = TRUE
  ?Image1{PROP:NoHeight} = TRUE
  IF SELF.OriginalRequest <> InsertRecord
    ?Image1{PROP:ImageBlob} = STU:Photograph{PROP:Handle}
  ELSE
    ?Image1{PROP:Text} = 'NoPhoto.BMP'
    PhotoChanged = TRUE
  END
  GLO:FileName = ''
  DO DisplayImage
  
  BRW2.AskProcedure = 1
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  FileLookup6.Init
  FileLookup6.ClearOnCancel = True
  FileLookup6.SetMask('Image Files','*.GIF;*.BMP;*.JPG;*.PCX') ! Set the file mask
  FileLookup6.AddMask('All Files','*.*')                   ! Add additional masks
  FileLookup6.WindowTitle='Choose a File'
  BRW2.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Enrollment.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  MAJ:Number = STU:Major                                   ! Assign linking field value
  Access:Majors.Fetch(MAJ:KeyNumber)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateEnrollment
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Button8
      !Call drag toolbox
      POST(EVENT:AlertKey,?STU:Major)
      
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?STU:Major
      IF Access:Students.TryValidateField(11)              ! Attempt to validate STU:Major in Students
        SELECT(?STU:Major)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?STU:Major
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?STU:Major{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?GLO:FileName
      !Display photo from selected disk file
      IF NOT TARGET{PROP:AcceptAll}
        ?Image1{PROP:NoWidth} = TRUE
        ?Image1{PROP:NoHeight} = TRUE
        ?Image1{PROP:Text} = GLO:FileName
        DO DisplayImage
        PhotoChanged = TRUE
      END
      
    OF ?LookupFile
      ThisWindow.Update
      GLO:FileName = FileLookup6.Ask(1)
      DISPLAY
      !Display photo from selected disk file
      IF NOT TARGET{PROP:AcceptAll} AND GLO:FileName <> ''
        ?Image1{PROP:NoWidth} = TRUE
        ?Image1{PROP:NoHeight} = TRUE
        ?Image1{PROP:Text} = GLO:FileName
        DO DisplayImage
        PhotoChanged = TRUE
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeCompleted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  !Update Photo BLOB on disk
  IF PhotoChanged = TRUE
    STU:Photograph{PROP:size} = 0
    STU:Photograph{PROP:Handle} = ?Image1{PROP:ImageBlob}
  END
  
  ReturnValue = PARENT.TakeCompleted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?STU:Major
    CASE EVENT()
    OF EVENT:AlertKey
      !Call drag toolbox
      IF NOT SelectMajorsThread
        GLO:DropThread = THREAD()
        GLO:DropControl = ?STU:Major
        SelectMajorsThread = START(SelectMajors)
        GLO:ThreadRef &= SelectMajorsThread
      END
      
    OF EVENT:Drop
      !Receive dropped data and close drag toolbox
      STU:Major = DROPID()
      DISPLAY
      POST(EVENT:CloseWindow,,SelectMajorsThread)
      SelectMajorsThread = 0
      SELF.Reset
      PRESSKEY(TabKey)
      
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all Selected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?STU:Major
      !Call drag toolbox
      IF SELF.OriginalRequest = InsertRecord AND NOT STU:Major
        GLO:DropThread = THREAD()
        GLO:DropControl = ?STU:Major
        SelectMajorsThread = START(SelectMajors)
        GLO:ThreadRef &= SelectMajorsThread
      END
      
    END
  ReturnValue = PARENT.TakeSelected()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:CloseWindow
      !Close drag toolbox
      IF SelectMajorsThread
        POST(EVENT:CloseWindow,,SelectMajorsThread)
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves = False
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

