

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL021.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! </summary>
UpdateGrades PROCEDURE 

LocalRequest         LONG                                  !
OriginalRequest      LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
WindowInitialized    LONG                                  !
ForceRefresh         LONG                                  !
CurrentTab           STRING(80)                            !
RecordFiltered       LONG                                  !
FullName             STRING(25)                            !
EditColumn           BYTE                                  !
DummyColumn          STRING(1)                             !
BRW1::View:Browse    VIEW(Enrollment)
                       PROJECT(ENR:MidtermExam)
                       PROJECT(ENR:FinalExam)
                       PROJECT(ENR:TermPaper)
                       PROJECT(ENR:ClassNumber)
                       PROJECT(ENR:StudentNumber)
                       JOIN(CLA:KeyClassNumber,ENR:ClassNumber)
                         PROJECT(CLA:ScheduledTime)
                         PROJECT(CLA:ClassNumber)
                         PROJECT(CLA:CourseNumber)
                         JOIN(COU:KeyNumber,CLA:CourseNumber)
                           PROJECT(COU:Description)
                           PROJECT(COU:Number)
                         END
                       END
                       JOIN(STU:KeyStudentNumber,ENR:StudentNumber)
                         PROJECT(STU:Number)
                       END
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
COU:Description        LIKE(COU:Description)          !List box control field - type derived from field
COU:Description_NormalFG LONG                         !Normal forground color
COU:Description_NormalBG LONG                         !Normal background color
COU:Description_SelectedFG LONG                       !Selected forground color
COU:Description_SelectedBG LONG                       !Selected background color
CLA:ScheduledTime      LIKE(CLA:ScheduledTime)        !List box control field - type derived from field
CLA:ScheduledTime_NormalFG LONG                       !Normal forground color
CLA:ScheduledTime_NormalBG LONG                       !Normal background color
CLA:ScheduledTime_SelectedFG LONG                     !Selected forground color
CLA:ScheduledTime_SelectedBG LONG                     !Selected background color
FullName               LIKE(FullName)                 !List box control field - type derived from local data
FullName_NormalFG      LONG                           !Normal forground color
FullName_NormalBG      LONG                           !Normal background color
FullName_SelectedFG    LONG                           !Selected forground color
FullName_SelectedBG    LONG                           !Selected background color
ENR:MidtermExam        LIKE(ENR:MidtermExam)          !List box control field - type derived from field
ENR:FinalExam          LIKE(ENR:FinalExam)            !List box control field - type derived from field
ENR:TermPaper          LIKE(ENR:TermPaper)            !List box control field - type derived from field
DummyColumn            LIKE(DummyColumn)              !List box control field - type derived from local data
ENR:ClassNumber        LIKE(ENR:ClassNumber)          !Browse hot field - type derived from field
ENR:StudentNumber      LIKE(ENR:StudentNumber)        !Browse key field - type derived from field
CLA:ClassNumber        LIKE(CLA:ClassNumber)          !Related join file key field - type derived from field
COU:Number             LIKE(COU:Number)               !Related join file key field - type derived from field
STU:Number             LIKE(STU:Number)               !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('Update Grades for a Class'),AT(,,288,140),CENTER,GRAY,MDI,HLP('~UpdateGrades'),SYSTEM
                       LIST,AT(5,5,275,116),USE(?List),HVSCROLL,COLUMN,FORMAT('67L(1)|_M*~Class~@S30@44L(1)|_M' & |
  '*~Time~@s20@51L(1)|_M*~Student~@s25@33R(8)|_M~Midterm~L(1)@n3@25R(8)|_M~Final~L(1)@n' & |
  '3@41R(8)_~Term Paper~L(1)@n3@4R(2)_@s1@'),FROM(Queue:Browse),IMM,MSG('Browsing Records')
                       BUTTON('&Change'),AT(75,70,42,12),USE(?Change),HIDE
                       BUTTON('Close'),AT(240,125,40,12),USE(?Close)
                       ENTRY(@n3),AT(128,126),USE(?EditEntry),RIGHT(7),HIDE
                       BUTTON('Help'),AT(0,0,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort0:StepClass StepLongClass                        ! Default Step Manager
BRW1::EIPManager     BrowseEIPManager                      ! Browse EIP Manager for Browse using ?List

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateGrades')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('FullName',FullName)                                ! Added by: BrowseBox(ABC)
  BIND('DummyColumn',DummyColumn)                          ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Enrollment.SetOpenRelated()
  Relate:Enrollment.Open                                   ! File Enrollment used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Enrollment,SELF) ! Initialize the browse manager
  SELF.Open(BrowseWindow)                                  ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowNumeric)     ! Moveable thumb based upon ENR:ClassNumber for sort order 1
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,ENR:SeqStu)      ! Add the sort order for ENR:SeqStu for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,ENR:ClassNumber,1,BRW1)        ! Initialize the browse locator using  using key: ENR:SeqStu , ENR:ClassNumber
  BRW1.SetFilter('(CLA:ClassNumber <<> 0)')                ! Apply filter expression to browse
  BRW1.AddField(COU:Description,BRW1.Q.COU:Description)    ! Field COU:Description is a hot field or requires assignment from browse
  BRW1.AddField(CLA:ScheduledTime,BRW1.Q.CLA:ScheduledTime) ! Field CLA:ScheduledTime is a hot field or requires assignment from browse
  BRW1.AddField(FullName,BRW1.Q.FullName)                  ! Field FullName is a hot field or requires assignment from browse
  BRW1.AddField(ENR:MidtermExam,BRW1.Q.ENR:MidtermExam)    ! Field ENR:MidtermExam is a hot field or requires assignment from browse
  BRW1.AddField(ENR:FinalExam,BRW1.Q.ENR:FinalExam)        ! Field ENR:FinalExam is a hot field or requires assignment from browse
  BRW1.AddField(ENR:TermPaper,BRW1.Q.ENR:TermPaper)        ! Field ENR:TermPaper is a hot field or requires assignment from browse
  BRW1.AddField(DummyColumn,BRW1.Q.DummyColumn)            ! Field DummyColumn is a hot field or requires assignment from browse
  BRW1.AddField(ENR:ClassNumber,BRW1.Q.ENR:ClassNumber)    ! Field ENR:ClassNumber is a hot field or requires assignment from browse
  BRW1.AddField(ENR:StudentNumber,BRW1.Q.ENR:StudentNumber) ! Field ENR:StudentNumber is a hot field or requires assignment from browse
  BRW1.AddField(CLA:ClassNumber,BRW1.Q.CLA:ClassNumber)    ! Field CLA:ClassNumber is a hot field or requires assignment from browse
  BRW1.AddField(COU:Number,BRW1.Q.COU:Number)              ! Field COU:Number is a hot field or requires assignment from browse
  BRW1.AddField(STU:Number,BRW1.Q.STU:Number)              ! Field STU:Number is a hot field or requires assignment from browse
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Enrollment.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW1::EIPManager                             ! Set the EIP manager
  SELF.AddEditControl(,1)
  SELF.AddEditControl(,6)
  SELF.AddEditControl(,11)
  SELF.AddEditControl(,19)
  SELF.DeleteAction = EIPAction:Always
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.ChangeControl=?Change
  END


BRW1.SetQueueRecord PROCEDURE

  CODE
  FullName = CLIP(STU:LastName) & ', ' & STU:FirstName
  PARENT.SetQueueRecord
  
  SELF.Q.COU:Description_NormalFG = -2147483645            ! Set color values for COU:Description
  SELF.Q.COU:Description_NormalBG = -1
  SELF.Q.COU:Description_SelectedFG = -2147483645
  SELF.Q.COU:Description_SelectedBG = -1
  SELF.Q.CLA:ScheduledTime_NormalFG = -2147483645          ! Set color values for CLA:ScheduledTime
  SELF.Q.CLA:ScheduledTime_NormalBG = -1
  SELF.Q.CLA:ScheduledTime_SelectedFG = -2147483645
  SELF.Q.CLA:ScheduledTime_SelectedBG = -1
  SELF.Q.FullName_NormalFG = -2147483645                   ! Set color values for FullName
  SELF.Q.FullName_NormalBG = -1
  SELF.Q.FullName_SelectedFG = -2147483645
  SELF.Q.FullName_SelectedBG = -1
  SELF.Q.FullName = FullName                               !Assign formula result to display queue

