

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL022.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Report
!!! </summary>
CourseEnrollment PROCEDURE 

RejectRecord         LONG                                  !
LocalRequest         LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
RecordsToProcess     LONG,AUTO                             !
RecordsProcessed     LONG,AUTO                             !
RecordsPerCycle      LONG,AUTO                             !
RecordsThisCycle     LONG,AUTO                             !
PercentProgress      BYTE                                  !
RecordStatus         BYTE,AUTO                             !
Cnt_StudentNumber    LONG                                  !
Cnt_StudentNumber_2  LONG                                  !
FinalGrade           DECIMAL(5,2)                          !
FinalLetterGrade     STRING(1)                             !
Progress:Thermometer BYTE                                  !
Process:View         VIEW(Courses)
                       PROJECT(COU:CompleteDescription)
                       PROJECT(COU:Description)
                       PROJECT(COU:Number)
                       JOIN(CLA:KeyCourseNumber,COU:Number)
                         PROJECT(CLA:RoomNumber)
                         PROJECT(CLA:ScheduledTime)
                         PROJECT(CLA:TeacherNumber)
                         PROJECT(CLA:ClassNumber)
                         JOIN(TEA:KeyTeacherNumber,CLA:TeacherNumber)
                           PROJECT(TEA:FirstName)
                           PROJECT(TEA:LastName)
                         END
                         JOIN(ENR:SeqStu,CLA:ClassNumber)
                           PROJECT(ENR:FinalExam)
                           PROJECT(ENR:MidtermExam)
                           PROJECT(ENR:StudentNumber)
                           PROJECT(ENR:TermPaper)
                           JOIN(STU:KeyStudentNumber,ENR:StudentNumber)
                             PROJECT(STU:LastName)
                           END
                         END
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),DOUBLE,CENTER,GRAY,TIMER(1)
                       PROGRESS,AT(15,15,111,12),USE(Progress:Thermometer),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(1000,1000,6500,7833),PRE(Rpt),FONT('Arial',10,COLOR:Black),THOUS
REPORTBrk              BREAK(LocalRequest)
                         HEADER,AT(0,0),ALONE
                           STRING('Enrollment Report'),AT(1948,2552,2958,406),FONT('Times New Roman',20,COLOR:Black,FONT:bold+FONT:italic), |
  CENTER
                         END
DescriptionBREAK         BREAK(COU:Description)
                           HEADER,AT(0,0,,833),FONT('Arial',10,COLOR:Black,FONT:bold),PAGEBEFORE(-1)
                             STRING(@s40),AT(0,0),USE(COU:Description),FONT(,18,COLOR:Black)
                             TEXT,AT(781,229,5635,573),USE(COU:CompleteDescription),BOXED,COLOR(COLOR:Silver),RESIZE
                           END
ClassBREAK                 BREAK(CLA:ClassNumber)
                             HEADER,AT(0,0,,1313),FONT('Arial',10,COLOR:Black,FONT:bold)
                               GROUP('Class'),AT(1010,94,1594,760),BOXED
                                 STRING(@n4),AT(1844,323),USE(CLA:RoomNumber)
                                 STRING('Room'),AT(1156,323),USE(?String25)
                                 STRING(@s20),AT(1156,563,1094),USE(CLA:ScheduledTime)
                               END
                               GROUP('Teacher'),AT(4458,94,1594,760),BOXED
                                 STRING(@s20),AT(4521,563),USE(TEA:LastName)
                                 STRING(@s20),AT(4521,323),USE(TEA:FirstName)
                               END
                               LINE,AT(1021,1219,5500,0)
                               STRING('Midterm Exam'),AT(2323,958)
                               STRING('Final Exam'),AT(3479,958)
                               STRING('Term Paper'),AT(4427,958)
                               STRING('Final Grade'),AT(5417,958)
                               STRING('Student Number'),AT(1063,958)
                             END
Detail1                      DETAIL,AT(,,,250),USE(?Detail1),FONT('Arial',8,COLOR:Black)
                               STRING(@n-13),AT(1052,0,1073),USE(ENR:StudentNumber)
                               STRING(@n-6),AT(2323,0,958),USE(ENR:MidtermExam)
                               STRING(@n-6),AT(3479,0,750),USE(ENR:FinalExam)
                               STRING(@n-6),AT(4427,0,781),USE(ENR:TermPaper)
                               STRING(@s20),AT(31,0,948),USE(STU:LastName)
                               STRING(@n5.2),AT(5417,0,740),USE(FinalGrade)
                               STRING(@s1),AT(5938,10),USE(FinalLetterGrade)
                               LINE,AT(10,208,6490,0)
                             END
                             FOOTER,AT(0,0,,458),WITHPRIOR(1)
                               STRING(@n5),AT(156,125),USE(Cnt_StudentNumber_2),CNT,RESET(ClassBREAK)
                               STRING('Students Enrolled in this Class'),AT(708,125)
                             END
                           END
                           FOOTER,AT(0,0,,448),WITHPRIOR(1)
                             STRING(@n5),AT(156,104),USE(Cnt_StudentNumber),CNT,RESET(DescriptionBREAK)
                             STRING('Students Enrolled in this Course'),AT(708,104)
                           END
                         END
                       END
                       FOOTER,AT(1000,8833,,583),FONT('Times New Roman',9,COLOR:Black,FONT:bold+FONT:italic)
                         STRING('Page '),AT(5833,292)
                         STRING(@n5),AT(6115,292),PAGENO
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                       ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('CourseEnrollment')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Courses.SetOpenRelated()
  Relate:Courses.Open                                      ! File Courses used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{PROP:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Courses, ?Progress:PctText, Progress:Thermometer, ProgressMgr, COU:Description)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(COU:KeyDescription)
  ThisReport.SetFilter('ENR:StudentNumber <<> 0')
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{PROP:Text} = ''
  Relate:Courses.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom = True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Courses.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  FinalGrade = (ENR:MidtermExam + (ENR:FinalExam * 2) + ENR:TermPaper) / 4
  CASE (INT(FinalGrade / 10))
  OF 9
    FinalLetterGrade = 'A'
  OF 8
    FinalLetterGrade = 'B'
  OF 7
    FinalLetterGrade = 'C'
  OF 6
    FinalLetterGrade = 'D'
  ELSE
    FinalLetterGrade = 'F'
  END
  ReturnValue = PARENT.TakeRecord()
  PRINT(Rpt:Detail1)
  RETURN ReturnValue

