

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL026.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Report
!!! </summary>
FinalGrades PROCEDURE 

RejectRecord         LONG                                  !
LocalRequest         LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
RecordsToProcess     LONG,AUTO                             !
RecordsProcessed     LONG,AUTO                             !
RecordsPerCycle      LONG,AUTO                             !
RecordsThisCycle     LONG,AUTO                             !
PercentProgress      BYTE                                  !
RecordStatus         BYTE,AUTO                             !
Cnt_StudentNumber    LONG                                  !
Cnt_StudentNumber_2  LONG                                  !
FinalGrade           DECIMAL(5,2)                          !
FinalLetterGrade     STRING(1)                             !
FullName             STRING(35)                            !
Progress:Thermometer BYTE                                  !
Process:View         VIEW(Students)
                       PROJECT(STU:FirstName)
                       PROJECT(STU:LastName)
                       PROJECT(STU:Number)
                       JOIN(ENR:StuSeq,STU:Number)
                         PROJECT(ENR:FinalExam)
                         PROJECT(ENR:MidtermExam)
                         PROJECT(ENR:StudentNumber)
                         PROJECT(ENR:TermPaper)
                         PROJECT(ENR:ClassNumber)
                         JOIN(CLA:KeyClassNumber,ENR:ClassNumber)
                           PROJECT(CLA:TeacherNumber)
                           PROJECT(CLA:CourseNumber)
                           JOIN(TEA:KeyTeacherNumber,CLA:TeacherNumber)
                             PROJECT(TEA:LastName)
                           END
                           JOIN(COU:KeyNumber,CLA:CourseNumber)
                             PROJECT(COU:Description)
                           END
                         END
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),DOUBLE,CENTER,GRAY,TIMER(1)
                       PROGRESS,AT(15,15,111,12),USE(Progress:Thermometer),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(1000,2010,6500,6823),PRE(Rpt),FONT('Arial',10,COLOR:Black),THOUS
                       HEADER,AT(1000,1000,6500,1000)
                         STRING('TopSpeed University'),AT(2010,156),USE(?String19),FONT(,18,COLOR:Black,FONT:bold+FONT:italic)
                         STRING('Final Grade Report'),AT(2344,604),USE(?String20),FONT(,14,COLOR:Black,FONT:bold+FONT:underline)
                       END
STU:NumberBreak        BREAK(STU:Number)
                         HEADER,AT(0,0,,802)
                           STRING(@s35),AT(1146,94),USE(FullName),FONT(,,COLOR:Black,FONT:bold)
                           STRING('Student:'),AT(479,94),USE(?String23),FONT(,,COLOR:Black,FONT:bold)
                           STRING(@P###-##-####P),AT(1146,281,823,208),USE(ENR:StudentNumber),FONT(,,COLOR:Black,FONT:bold)
                           STRING('Term Paper'),AT(4667,583),USE(?String13),FONT(,,COLOR:Black,FONT:bold+FONT:underline)
                           STRING('Final Grade'),AT(5625,583),USE(?String16),FONT(,,COLOR:Black,FONT:bold+FONT:underline)
                           STRING('Class'),AT(83,583),USE(?String17),FONT(,,COLOR:Black,FONT:bold+FONT:underline)
                           STRING('Instructor'),AT(2010,573),USE(?String18),FONT(,,COLOR:Black,FONT:bold+FONT:underline)
                           STRING('Mid-Term'),AT(3521,583),USE(?String15),FONT(,,COLOR:Black,FONT:bold+FONT:underline)
                           STRING('Final'),AT(4208,583),USE(?String14),FONT(,,COLOR:Black,FONT:bold+FONT:underline)
                         END
Detail1                  DETAIL,AT(10,,6490,260),USE(?Detail1),FONT('Arial',8,COLOR:Black)
                           STRING(@n-6),AT(3667,42,365,177),USE(ENR:MidtermExam)
                           STRING(@n-6),AT(4188,42,438,177),USE(ENR:FinalExam)
                           STRING(@n-6),AT(4990,42,365,177),USE(ENR:TermPaper)
                           STRING(@n5.2),AT(5677,42,313,177),USE(FinalGrade),RIGHT
                           STRING(@s1),AT(6115,42),USE(FinalLetterGrade)
                           STRING(@S30),AT(73,42),USE(COU:Description)
                           STRING(@S20),AT(2021,42),USE(TEA:LastName)
                         END
                         FOOTER,AT(0,0,,448),FONT('Arial',8,COLOR:Black),PAGEAFTER(-1)
                           LINE,AT(5510,31,1042,0),USE(?Line1),COLOR(COLOR:Black)
                           STRING(@n5.2),AT(5667,135),USE(FinalGrade,,?FinalGrade:2),RIGHT,AVE,RESET(STU:NumberBreak)
                           STRING('Overall GPA:'),AT(4656,135),USE(?String22),FONT(,,COLOR:Black,FONT:bold)
                         END
                       END
                       FOOTER,AT(1000,8833,,583),FONT('Times New Roman',9,COLOR:Black,FONT:bold+FONT:italic)
                         STRING('Page '),AT(5833,292)
                         STRING(@n5),AT(6115,292),PAGENO
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                       ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('FinalGrades')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Students.SetOpenRelated()
  Relate:Students.Open                                     ! File Students used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{PROP:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Students, ?Progress:PctText, Progress:Thermometer, ProgressMgr, STU:LastName)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(STU:KeyLastName)
  ThisReport.SetFilter('ENR:StudentNumber <<> 0')
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{PROP:Text} = ''
  Relate:Students.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom = True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Students.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  FinalGrade = (ENR:MidtermExam + (ENR:FinalExam * 2) + ENR:TermPaper) / 4
  CASE (INT(FinalGrade / 10))
  OF 9
    FinalLetterGrade = 'A'
  OF 8
    FinalLetterGrade = 'B'
  OF 7
    FinalLetterGrade = 'C'
  OF 6
    FinalLetterGrade = 'D'
  ELSE
    FinalLetterGrade = 'F'
  END
  FullName = CLIP(STU:FirstName) & ' ' & STU:LastName
  ReturnValue = PARENT.TakeRecord()
  PRINT(Rpt:Detail1)
  RETURN ReturnValue

