

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL027.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Report
!!! </summary>
StudentIDs PROCEDURE 

RejectRecord         LONG                                  !
LocalRequest         LONG                                  !
LocalResponse        LONG                                  !
WindowOpened         LONG                                  !
RecordsToProcess     LONG,AUTO                             !
RecordsProcessed     LONG,AUTO                             !
RecordsPerCycle      LONG,AUTO                             !
RecordsThisCycle     LONG,AUTO                             !
PercentProgress      BYTE                                  !
RecordStatus         BYTE,AUTO                             !
FilesOpened          BYTE                                  !
FullName             STRING(35)                            !
CSZ                  STRING(35)                            !
Progress:Thermometer BYTE                                  !
Process:View         VIEW(Students)
                       PROJECT(STU:Address)
                       PROJECT(STU:Address2)
                       PROJECT(STU:City)
                       PROJECT(STU:FirstName)
                       PROJECT(STU:LastName)
                       PROJECT(STU:Number)
                       PROJECT(STU:Photograph)
                       PROJECT(STU:State)
                       PROJECT(STU:Zip)
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),DOUBLE,CENTER,GRAY,TIMER(1)
                       PROGRESS,AT(15,15,111,12),USE(Progress:Thermometer),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(0,0,8500,11000),PRE(RPT),FONT('Arial',10,COLOR:Black,FONT:regular),THOUS
detail                 DETAIL,AT(,,4250,2198),USE(?detail)
                         BOX,AT(219,229,3729,1719),USE(?Box1),COLOR(COLOR:Black),LINEWIDTH(30),ROUND
                         STRING('TopSpeed University'),AT(448,333),USE(?String1),FONT(,12,COLOR:Black,FONT:bold+FONT:italic)
                         IMAGE,AT(2719,385),USE(?Image1)
                         STRING(@S20),AT(448,1219),USE(STU:Address)
                         STRING(@s20),AT(448,1385),USE(STU:Address2)
                         STRING('Student Identification'),AT(448,531),USE(?String2),FONT(,,COLOR:Black,FONT:bold)
                         STRING(@s35),AT(448,792),USE(FullName),TRN
                         STRING(@P###-##-####P),AT(448,969),USE(STU:Number),LEFT(1)
                         STRING(@s35),AT(448,1563),USE(CSZ),TRN
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                       ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('StudentIDs')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Students.SetOpenRelated()
  Relate:Students.Open                                     ! File Students used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{PROP:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Students, ?Progress:PctText, Progress:Thermometer, ProgressMgr, STU:LastName)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(STU:KeyLastName)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{PROP:Text} = ''
  Relate:Students.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom = True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Students.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  FullName = CLIP(STU:FirstName) & ' ' & STU:LastName
  CSZ = CLIP(STU:City) & ', ' & STU:State & ' ' & STU:Zip
  !Assign BLOB to IMAGE control
  Report$?Image1{PROP:NoWidth} = TRUE
  Report$?Image1{PROP:NoHeight} = TRUE
  Report$?Image1{PROP:ImageBlob} = STU:Photograph{PROP:Handle}
  IF Report$?Image1{PROP:Height} > 1000
    AspectRatio$ = Report$?Image1{PROP:Width}/Report$?Image1{PROP:Height}
    Report$?Image1{PROP:Height} = 1000
    Report$?Image1{PROP:Width} = 1000 * AspectRatio$
  END
  IF Report$?Image1{PROP:Width} > 1000
    AspectRatio$ = Report$?Image1{PROP:Height}/Report$?Image1{PROP:Width}
    Report$?Image1{PROP:Width} = 1000
    Report$?Image1{PROP:Height} = 1000 * AspectRatio$
  END
   
  
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

