

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL030.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Form
!!! </summary>
TabBarSettings PROCEDURE 

LOC:TabBarLocation   STRING(25)                            !
LOC:TabBarStyle      STRING(25)                            !
LOC:TabBarVisible    STRING(20)                            !
LOC:TabBarVisibleTemp STRING(5)                            !
Window               WINDOW('Tab Bar Settings'),AT(,,395,224),FONT('MS Sans Serif',8,,FONT:regular),RESIZE,GRAY, |
  MDI,SYSTEM
                       SHEET,AT(12,12,375,177),USE(?SHEET1)
                         TAB('Settings'),USE(?TAB1)
                           CHECK(' Visible'),AT(29,38),USE(LOC:TabBarVisible),TRN,VALUE('1','0')
                           OPTION('Location:'),AT(29,77,97,31),USE(LOC:TabBarLocation),BOXED
                             RADIO('Bottom'),AT(72,89),USE(?LOC:TabBarLocation:Radio0),TRN,VALUE('1')
                             RADIO('Top'),AT(37,89),USE(?LOC:TabBarLocation:Radio1),TRN,VALUE('0')
                           END
                           OPTION('Style:'),AT(29,136,281,28),USE(LOC:TabBarStyle),BOXED
                             RADIO('BlackAndWhite'),AT(83,148),USE(?LOC:TabBarStyle:Radio0),TRN,VALUE('1')
                             RADIO('Default'),AT(37,148),USE(?LOC:TabBarStyle:Radio1),TRN,VALUE('0')
                             RADIO('Colored'),AT(155,148),USE(?LOC:TabBarStyle:Radio2),TRN,VALUE('2')
                             RADIO('Squared'),AT(245,148),USE(?LOC:TabBarStyle:Radio3),TRN,VALUE('3')
                             RADIO('Boxed'),AT(203,148),USE(?LOC:TabBarStyle:Radio4),TRN,VALUE('4')
                           END
                           BUTTON('&OK'),AT(129,199,45,14),USE(?OkButton),LEFT,ICON('waok.ico'),DEFAULT
                           BUTTON('&Cancel'),AT(191,199,45,14),USE(?CancelButton),LEFT,ICON('waclose.ico'),STD(STD:Close)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeCompleted          PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('TabBarSettings')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?LOC:TabBarVisible
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(Window)                                        ! Open window
  LOC:TabBarVisibleTemp = IniMgr.Fetch('TabBar','Visible')
  If LOC:TabBarVisibleTemp = 'True'
     LOC:TabBarVisible = True
  Else
     LOC:TabBarVisible = False
  End   
  LOC:TabBarLocation = IniMgr.Fetch('TabBar','Location')   
  LOC:TabBarStyle    = IniMgr.Fetch('TabBar','Style')
  Do DefineListboxStyle
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?OkButton
      Post(Event:Completed)
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeCompleted PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  If LOC:TabBarVisible = True
     LOC:TabBarVisibleTemp = 'True'
  Else
     LOC:TabBarVisibleTemp = 'False'
  End   
  IniMgr.Update('TabBar','Visible',LOC:TabBarVisibleTemp)
  INIMgr.Update('TabBar','Location',LOC:TabBarLocation)
  IniMgr.Update('TabBar','Style',LOC:TabBarStyle)
  Post(EVENT:CloseWindow)
  ReturnValue = PARENT.TakeCompleted()
  RETURN ReturnValue

