

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('SCHOOL001.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('SCHOOL003.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Update the Enrollment File
!!! </summary>
UpdateEnrollment PROCEDURE 

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
OriginalRequest      LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
WindowInitialized    LONG                                  !
ForceRefresh         LONG                                  !
ActionMessage        CSTRING(40)                           !
RecordChanged        BYTE,AUTO                             !
SelectStudentsThread LONG                                  !
SelectClassesThread  LONG                                  !
History::ENR:Record  LIKE(ENR:RECORD),THREAD
QuickWindow          WINDOW('Update the Enrollment File'),AT(,,263,102),FONT('MS Sans Serif',8,COLOR:Black),CENTER, |
  GRAY,IMM,MDI,HLP('~UpdateEnrollment'),SYSTEM
                       PROMPT('&Student Number:'),AT(8,10),USE(?ENR:StudentNumber:Prompt)
                       ENTRY(@p###-##-####p),AT(64,10,52,10),USE(ENR:StudentNumber),RIGHT(1),ALRT(F10Key),ALRT(MouseRight), |
  DROPID('Students'),MSG('Press F10 to drag a Student'),TIP('Press F10 to drag a Student')
                       BUTTON('...'),AT(118,9,12,12),USE(?Button4)
                       STRING(@S20),AT(133,10),USE(STU:LastName)
                       PROMPT('&Class Number'),AT(8,31),USE(?ENR:ClassNumber:Prompt)
                       ENTRY(@p##-#####p),AT(64,31,40,10),USE(ENR:ClassNumber),RIGHT(1),ALRT(F10Key),ALRT(MouseRight), |
  DROPID('Classes'),MSG('Press F10 to drag a Class'),TIP('Press F10 to drag a Class')
                       BUTTON('...'),AT(107,30,12,12),USE(?Button5)
                       STRING(@S30),AT(133,31),USE(COU:Description)
                       STRING(@s20),AT(133,42),USE(CLA:ScheduledTime)
                       PROMPT('Midterm:'),AT(11,63),USE(?ENR:MidtermExam:Prompt)
                       ENTRY(@n3),AT(41,63,40,10),USE(ENR:MidtermExam)
                       PROMPT('Final:'),AT(96,63),USE(?ENR:FinalExam:Prompt)
                       ENTRY(@n3),AT(115,63,40,10),USE(ENR:FinalExam)
                       PROMPT('Term Paper:'),AT(170,63),USE(?ENR:TermPaper:Prompt)
                       ENTRY(@n3),AT(212,63,40,10),USE(ENR:TermPaper)
                       BUTTON('OK'),AT(4,84,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(53,84,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(102,84,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Enrollment Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Enrollment Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateEnrollment')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?ENR:StudentNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(ENR:Record,History::ENR:Record)
  SELF.AddHistoryField(?ENR:StudentNumber,1)
  SELF.AddHistoryField(?ENR:ClassNumber,2)
  SELF.AddHistoryField(?ENR:MidtermExam,3)
  SELF.AddHistoryField(?ENR:FinalExam,4)
  SELF.AddHistoryField(?ENR:TermPaper,5)
  SELF.AddUpdateFile(Access:Enrollment)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Classes.SetOpenRelated()
  Relate:Classes.Open                                      ! File Classes used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Enrollment
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Classes.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  STU:Number = ENR:StudentNumber                           ! Assign linking field value
  Access:Students.Fetch(STU:KeyStudentNumber)
  CLA:ClassNumber = ENR:ClassNumber                        ! Assign linking field value
  Access:Classes.Fetch(CLA:KeyClassNumber)
  COU:Number = CLA:CourseNumber                            ! Assign linking field value
  Access:Courses.Fetch(COU:KeyNumber)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectClasses
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Button4
      !Call drag toolbox
      POST(EVENT:AlertKey,?ENR:StudentNumber)
      
    OF ?Button5
      !Call drag toolbox
      POST(EVENT:AlertKey,?ENR:ClassNumber)
      
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?ENR:StudentNumber
      IF Access:Enrollment.TryValidateField(1)             ! Attempt to validate ENR:StudentNumber in Enrollment
        SELECT(?ENR:StudentNumber)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ENR:StudentNumber
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?ENR:StudentNumber{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?ENR:ClassNumber
      IF NOT QuickWindow{PROP:AcceptAll}
        CLA:ClassNumber = ENR:ClassNumber
        IF Access:Classes.TryFetch(CLA:KeyClassNumber)
          IF SELF.Run(1,SelectRecord) = RequestCompleted
            ENR:ClassNumber = CLA:ClassNumber
          ELSE
            SELECT(?ENR:ClassNumber)
            CYCLE
          END
        END
      END
      ThisWindow.Reset(0)
      IF Access:Enrollment.TryValidateField(2)             ! Attempt to validate ENR:ClassNumber in Enrollment
        SELECT(?ENR:ClassNumber)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ENR:ClassNumber
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?ENR:ClassNumber{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?ENR:MidtermExam
      IF Access:Enrollment.TryValidateField(3)             ! Attempt to validate ENR:MidtermExam in Enrollment
        SELECT(?ENR:MidtermExam)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ENR:MidtermExam
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?ENR:MidtermExam{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?ENR:FinalExam
      IF Access:Enrollment.TryValidateField(4)             ! Attempt to validate ENR:FinalExam in Enrollment
        SELECT(?ENR:FinalExam)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ENR:FinalExam
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?ENR:FinalExam{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?ENR:TermPaper
      IF Access:Enrollment.TryValidateField(5)             ! Attempt to validate ENR:TermPaper in Enrollment
        SELECT(?ENR:TermPaper)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ENR:TermPaper
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?ENR:TermPaper{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?ENR:StudentNumber
    CASE EVENT()
    OF EVENT:AlertKey
      !Call drag toolbox
      IF NOT SelectStudentsThread
        GLO:DropThread = THREAD()
        GLO:DropControl = ?ENR:StudentNumber
        SelectStudentsThread = START(SelectStudents)
        GLO:ThreadRef &= SelectStudentsThread
      END
      
    OF EVENT:Drop
      !Receive dropped data and close drag toolbox
      ENR:StudentNumber = DEFORMAT(DROPID(),@P###-##-####P)
      DISPLAY
      POST(EVENT:CloseWindow,,SelectStudentsThread)
      SelectStudentsThread = 0
      SELF.Reset
      PRESSKEY(TabKey)
      PRESSKEY(TabKey)
      
    END
  OF ?ENR:ClassNumber
    CASE EVENT()
    OF EVENT:AlertKey
      !Call drag toolbox
      IF NOT SelectClassesThread
        GLO:DropThread = THREAD()
        GLO:DropControl = ?ENR:ClassNumber
        SelectClassesThread = START(SelectClasses)
        GLO:ThreadRef &= SelectClassesThread
      END
      
    OF EVENT:Drop
      !Receive dropped data and close drag toolbox
      ENR:ClassNumber = DEFORMAT(DROPID(),@P##-#####P)
      DISPLAY
      POST(EVENT:CloseWindow,,SelectClassesThread)
      SelectClassesThread = 0
      SELF.Reset
      PRESSKEY(TabKey)
      PRESSKEY(TabKey)
      
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all Selected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?ENR:StudentNumber
      !Call drag toolbox
      IF SELF.OriginalRequest = InsertRecord AND NOT ENR:StudentNumber
        GLO:DropThread = THREAD()
        GLO:DropControl = ?ENR:StudentNumber
        SelectStudentsThread = START(SelectStudents)
        GLO:ThreadRef &= SelectStudentsThread
      END
      
    OF ?ENR:ClassNumber
      !Call drag toolbox
      IF SELF.OriginalRequest = InsertRecord AND NOT ENR:ClassNumber
        GLO:DropThread = THREAD()
        GLO:DropControl = ?ENR:ClassNumber
        SelectClassesThread = START(SelectClasses)
        GLO:ThreadRef &= SelectClassesThread
      END
      
    END
  ReturnValue = PARENT.TakeSelected()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:CloseWindow
      !Close drag toolbox
      IF SelectStudentsThread
        POST(EVENT:CloseWindow,,SelectStudentsThread)
      END
      IF SelectClassesThread
        POST(EVENT:CloseWindow,,SelectClassesThread)
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

