

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL004.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('SCHOOL005.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('SCHOOL006.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Update the Classes File
!!! </summary>
UpdateClasses PROCEDURE 

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
OriginalRequest      LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
WindowInitialized    LONG                                  !
ForceRefresh         LONG                                  !
RecordFiltered       LONG                                  !
ActionMessage        CSTRING(40)                           !
RecordChanged        BYTE,AUTO                             !
SelectCoursesThread  LONG                                  !
SelectTeachersThread LONG                                  !
History::CLA:Record  LIKE(CLA:RECORD),THREAD
QuickWindow          WINDOW('Update the Classes File'),AT(,,164,138),FONT('MS Sans Serif',8,COLOR:Black),CENTER, |
  GRAY,IMM,MDI,HLP('~UpdateClasses'),SYSTEM
                       SHEET,AT(2,3,158,114),USE(?CurrentTab)
                         TAB('General'),USE(?TAB1)
                           PROMPT('&Class Number:'),AT(7,21),USE(?CLA:ClassNumber:Prompt),TRN
                           ENTRY(@P##-#####P),AT(71,21,40,10),USE(CLA:ClassNumber),RIGHT(1)
                           PROMPT('&Course Number:'),AT(7,34),USE(?CLA:CourseNumber:Prompt),TRN
                           ENTRY(@n4),AT(71,34,24,10),USE(CLA:CourseNumber),RIGHT(1),ALRT(F10Key),DROPID('Courses')
                           BUTTON('...'),AT(98,33,12,12),USE(?Button7)
                           STRING(@S20),AT(71,47),USE(COU:Description),TRN
                           ENTRY(@p###-##-####p),AT(71,60,,10),USE(CLA:TeacherNumber),RIGHT(1),ALRT(F10Key),DROPID('Teachers')
                           BUTTON('...'),AT(128,60,12,12),USE(?Button7:2)
                           PROMPT('&Teacher Number:'),AT(7,60),USE(?CLA:TeacherNumber:Prompt),TRN
                           STRING(@S20),AT(71,73),USE(TEA:LastName),TRN
                           PROMPT('Room Number:'),AT(7,90),USE(?CLA:RoomNumber:Prompt),TRN
                           ENTRY(@n4),AT(71,90,40,10),USE(CLA:RoomNumber)
                           PROMPT('Scheduled Time:'),AT(7,103),USE(?CLA:ScheduledTime:Prompt),TRN
                           ENTRY(@s20),AT(71,103,84,10),USE(CLA:ScheduledTime)
                         END
                       END
                       BUTTON('OK'),AT(17,120,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(66,120,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(115,120,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Classes Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Classes Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateClasses')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?CLA:ClassNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(CLA:Record,History::CLA:Record)
  SELF.AddHistoryField(?CLA:ClassNumber,1)
  SELF.AddHistoryField(?CLA:CourseNumber,2)
  SELF.AddHistoryField(?CLA:TeacherNumber,3)
  SELF.AddHistoryField(?CLA:RoomNumber,4)
  SELF.AddHistoryField(?CLA:ScheduledTime,5)
  SELF.AddUpdateFile(Access:Classes)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Classes.SetOpenRelated()
  Relate:Classes.Open                                      ! File Classes used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Classes
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Classes.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  TEA:Number = CLA:TeacherNumber                           ! Assign linking field value
  Access:Teachers.Fetch(TEA:KeyTeacherNumber)
  COU:Number = CLA:CourseNumber                            ! Assign linking field value
  Access:Courses.Fetch(COU:KeyNumber)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?CLA:CourseNumber
      !Close drag toolbox
      IF SelectCoursesThread
        POST(EVENT:CloseWindow,,SelectCoursesThread)
      END
      
    OF ?Button7
      !Call drag toolbox
      POST(EVENT:AlertKey,?CLA:CourseNumber)
      
    OF ?CLA:TeacherNumber
      !Close drag toolbox
      IF SelectTeachersThread
        POST(EVENT:CloseWindow,,SelectTeachersThread)
        SelectTeachersThread = 0
      END
      
    OF ?Button7:2
      !Call drag toolbox
      POST(EVENT:AlertKey,?CLA:TeacherNumber)
      
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?CLA:CourseNumber
      IF Access:Classes.TryValidateField(2)                ! Attempt to validate CLA:CourseNumber in Classes
        SELECT(?CLA:CourseNumber)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?CLA:CourseNumber
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?CLA:CourseNumber{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?CLA:TeacherNumber
      IF Access:Classes.TryValidateField(3)                ! Attempt to validate CLA:TeacherNumber in Classes
        SELECT(?CLA:TeacherNumber)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?CLA:TeacherNumber
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?CLA:TeacherNumber{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?CLA:CourseNumber
    CASE EVENT()
    OF EVENT:AlertKey
      !Call drag toolbox
      IF NOT SelectCoursesThread
        GLO:DropThread = THREAD()
        GLO:DropControl = ?CLA:CourseNumber
        SelectCoursesThread = START(SelectCourses)
        GLO:ThreadRef &= SelectCoursesThread
      END
      
    OF EVENT:Drop
      !Receive dropped data and close drag toolbox
      CLA:CourseNumber = DROPID()
      DISPLAY
      POST(EVENT:CloseWindow,,SelectCoursesThread)
      SelectCoursesThread = 0
      SELF.Reset
      PRESSKEY(TabKey)
      PRESSKEY(TabKey)
      
    END
  OF ?CLA:TeacherNumber
    CASE EVENT()
    OF EVENT:AlertKey
      !Call drag toolbox
      IF NOT SelectTeachersThread
        GLO:DropThread = THREAD()
        GLO:DropControl = ?CLA:TeacherNumber
        SelectTeachersThread = START(SelectTeachers)
        GLO:ThreadRef &= SelectTeachersThread
      END
      
    OF EVENT:Drop
      CLA:TeacherNumber = DROPID()
      DISPLAY
      POST(EVENT:CloseWindow,,SelectTeachersThread)
      SelectTeachersThread = 0
      SELF.Reset
      PRESSKEY(TabKey)
      PRESSKEY(TabKey)
      
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all Selected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?CLA:CourseNumber
      !Call drag toolbox
      IF SELF.OriginalRequest = InsertRecord AND NOT CLA:CourseNumber
        GLO:DropThread = THREAD()
        GLO:DropControl = ?CLA:CourseNumber
        SelectCoursesThread = START(SelectCourses)
        GLO:ThreadRef &= SelectCoursesThread
      END
      
    OF ?CLA:TeacherNumber
      !Call drag toolbox
      IF SELF.OriginalRequest = InsertRecord AND NOT CLA:TeacherNumber
        GLO:DropThread = THREAD()
        GLO:DropControl = ?CLA:TeacherNumber
        SelectTeachersThread = START(SelectTeachers)
        GLO:ThreadRef &= SelectTeachersThread
      END
      
    END
  ReturnValue = PARENT.TakeSelected()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:CloseWindow
      !Close drag thread
      IF SelectCoursesThread
        POST(EVENT:CloseWindow,,SelectCoursesThread)
      END
      !Close drag thread
      IF SelectTeachersThread
        POST(EVENT:CloseWindow,,SelectTeachersThread)
        SelectTeachersThread = 0
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

