

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL013.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('SCHOOL004.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('SCHOOL014.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Update the Teachers File
!!! </summary>
UpdateTeachers PROCEDURE 

CurrentTab           STRING(80)                            !
LocalRequest         LONG                                  !
OriginalRequest      LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
WindowInitialized    LONG                                  !
ForceRefresh         LONG                                  !
RecordFiltered       LONG                                  !
ActionMessage        CSTRING(40)                           !
RecordChanged        BYTE,AUTO                             !
SelectMajorsThread   LONG                                  !
BRW2::View:Browse    VIEW(Classes)
                       PROJECT(CLA:ClassNumber)
                       PROJECT(CLA:RoomNumber)
                       PROJECT(CLA:ScheduledTime)
                       PROJECT(CLA:TeacherNumber)
                       PROJECT(CLA:CourseNumber)
                       JOIN(COU:KeyNumber,CLA:CourseNumber)
                         PROJECT(COU:Description)
                         PROJECT(COU:Number)
                       END
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
CLA:ClassNumber        LIKE(CLA:ClassNumber)          !List box control field - type derived from field
COU:Description        LIKE(COU:Description)          !List box control field - type derived from field
CLA:RoomNumber         LIKE(CLA:RoomNumber)           !List box control field - type derived from field
CLA:ScheduledTime      LIKE(CLA:ScheduledTime)        !List box control field - type derived from field
CLA:TeacherNumber      LIKE(CLA:TeacherNumber)        !Browse key field - type derived from field
COU:Number             LIKE(COU:Number)               !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::TEA:Record  LIKE(TEA:RECORD),THREAD
QuickWindow          WINDOW('Update the Teachers File'),AT(,,159,177),FONT('MS Sans Serif',8,COLOR:Black),GRAY, |
  IMM,MDI,HLP('~UpdateTeachers'),SYSTEM
                       SHEET,AT(4,6,151,151),USE(?CurrentTab)
                         TAB('General'),USE(?TAB1)
                           PROMPT('&Number:'),AT(8,26),USE(?Tea:Number:Prompt)
                           ENTRY(@P###-##-####P),AT(53,26,,10),USE(TEA:Number),RIGHT(1)
                           PROMPT('&First Name:'),AT(8,39),USE(?Tea:FirstName:Prompt)
                           ENTRY(@S20),AT(53,39,84,10),USE(TEA:FirstName)
                           PROMPT('&Last Name:'),AT(8,52),USE(?Tea:LastName:Prompt)
                           ENTRY(@S20),AT(53,52,84,10),USE(TEA:LastName)
                           PROMPT('&Address:'),AT(8,66),USE(?Tea:Address:Prompt)
                           ENTRY(@S20),AT(53,66,84,10),USE(TEA:Address)
                           PROMPT('&City:'),AT(8,81),USE(?Tea:City:Prompt)
                           ENTRY(@S20),AT(53,81,84,10),USE(TEA:City)
                           PROMPT('&State:'),AT(8,95),USE(?Tea:State:Prompt)
                           ENTRY(@S2),AT(53,95,40,10),USE(TEA:State)
                           PROMPT('&Zip:'),AT(8,108),USE(?Tea:Zip:Prompt)
                           ENTRY(@n05),AT(53,108,40,10),USE(TEA:Zip)
                           PROMPT('&Telephone:'),AT(8,122),USE(?Tea:Telephone:Prompt)
                           ENTRY(@s12),AT(53,122,52,10),USE(TEA:Telephone)
                           PROMPT('Department:'),AT(8,137),USE(?Tea:Department:Prompt)
                           ENTRY(@n4),AT(53,137,21,10),USE(TEA:Department),ALRT(F10Key),DROPID('Majors')
                           BUTTON('...'),AT(77,137,12,12),USE(?Button7)
                           STRING(@S15),AT(90,137),USE(MAJ:Description)
                         END
                         TAB('Classes'),USE(?ClassesTab)
                           LIST,AT(8,26,143,124),USE(?Browse:2),HVSCROLL,FORMAT('52L(2)|M~Class Number~@P##-#####P' & |
  '@120L(2)|M~Description~@S30@48R(2)|M~Room Number~C(0)@n4@80L(2)|M~Scheduled Time~@s20@'), |
  FROM(Queue:Browse:2),IMM,MSG('Browsing Records')
                           BUTTON('&Insert'),AT(8,119,45,14),USE(?Insert:3),HIDE
                           BUTTON('&Change'),AT(57,119,45,14),USE(?Change:3),HIDE
                           BUTTON('&Delete'),AT(106,119,45,14),USE(?Delete:3),HIDE
                         END
                       END
                       BUTTON('OK'),AT(12,159,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(61,159,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(110,159,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)                    ! Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW2::Sort0:StepClass StepLongClass                        ! Default Step Manager
ToolbarForm          ToolbarUpdateClass                    ! Form Toolbar Manager
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Teachers Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Teachers Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateTeachers')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Tea:Number:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(TEA:Record,History::TEA:Record)
  SELF.AddHistoryField(?TEA:Number,1)
  SELF.AddHistoryField(?TEA:FirstName,2)
  SELF.AddHistoryField(?TEA:LastName,3)
  SELF.AddHistoryField(?TEA:Address,4)
  SELF.AddHistoryField(?TEA:City,5)
  SELF.AddHistoryField(?TEA:State,6)
  SELF.AddHistoryField(?TEA:Zip,7)
  SELF.AddHistoryField(?TEA:Telephone,8)
  SELF.AddHistoryField(?TEA:Department,9)
  SELF.AddUpdateFile(Access:Teachers)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Classes.SetOpenRelated()
  Relate:Classes.Open                                      ! File Classes used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Teachers
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Classes,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon CLA:TeacherNumber for sort order 1
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,CLA:KeyTeacherNumber) ! Add the sort order for CLA:KeyTeacherNumber for sort order 1
  BRW2.AddRange(CLA:TeacherNumber,Relate:Classes,Relate:Teachers) ! Add file relationship range limit for sort order 1
  BRW2.AddField(CLA:ClassNumber,BRW2.Q.CLA:ClassNumber)    ! Field CLA:ClassNumber is a hot field or requires assignment from browse
  BRW2.AddField(COU:Description,BRW2.Q.COU:Description)    ! Field COU:Description is a hot field or requires assignment from browse
  BRW2.AddField(CLA:RoomNumber,BRW2.Q.CLA:RoomNumber)      ! Field CLA:RoomNumber is a hot field or requires assignment from browse
  BRW2.AddField(CLA:ScheduledTime,BRW2.Q.CLA:ScheduledTime) ! Field CLA:ScheduledTime is a hot field or requires assignment from browse
  BRW2.AddField(CLA:TeacherNumber,BRW2.Q.CLA:TeacherNumber) ! Field CLA:TeacherNumber is a hot field or requires assignment from browse
  BRW2.AddField(COU:Number,BRW2.Q.COU:Number)              ! Field COU:Number is a hot field or requires assignment from browse
  BRW2.AskProcedure = 1
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Classes.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  MAJ:Number = TEA:Department                              ! Assign linking field value
  Access:Majors.Fetch(MAJ:KeyNumber)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateClasses
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Button7
      !Call drag toolbox
      POST(EVENT:AlertKey,?Tea:Department)
      
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?TEA:Department
      IF Access:Teachers.TryValidateField(9)               ! Attempt to validate TEA:Department in Teachers
        SELECT(?TEA:Department)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?TEA:Department
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?TEA:Department{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?TEA:Department
    CASE EVENT()
    OF EVENT:AlertKey
      !Call drag toolbox
      IF NOT SelectMajorsThread
        GLO:DropThread = THREAD()
        GLO:DropControl = ?Tea:Department
        SelectMajorsThread = START(SelectMajors)
        GLO:ThreadRef &= SelectMajorsThread
      END
      
    OF EVENT:Drop
      !Receive dropped data and close drag toolbox
      Tea:Department = DROPID()
      DISPLAY
      POST(EVENT:CloseWindow,,SelectMajorsThread)
      SelectMajorsThread = 0
      SELF.Reset
      PRESSKEY(TabKey)
      PRESSKEY(TabKey)
      
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all Selected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?TEA:Department
      !Call drag toolbox
      IF SELF.OriginalRequest = InsertRecord AND NOT Tea:Department
        GLO:DropThread = THREAD()
        GLO:DropControl = ?Tea:Department
        SelectMajorsThread = START(SelectMajors)
        GLO:ThreadRef &= SelectMajorsThread
      END
      
    END
  ReturnValue = PARENT.TakeSelected()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:CloseWindow
      !Close drag toolbox
      IF SelectMajorsThread
        POST(EVENT:CloseWindow,,SelectMajorsThread)
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END

