

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL023.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Report
!!! </summary>
AttendanceSheets PROCEDURE 

RejectRecord         LONG                                  !
LocalRequest         LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
RecordsToProcess     LONG,AUTO                             !
RecordsProcessed     LONG,AUTO                             !
RecordsPerCycle      LONG,AUTO                             !
RecordsThisCycle     LONG,AUTO                             !
PercentProgress      BYTE                                  !
RecordStatus         BYTE,AUTO                             !
Cnt_StudentNumber    LONG                                  !
Cnt_StudentNumber_2  LONG                                  !
FinalGrade           DECIMAL(5,2)                          !
Progress:Thermometer BYTE                                  !
Process:View         VIEW(Courses)
                       PROJECT(COU:Description)
                       PROJECT(COU:Number)
                       JOIN(CLA:KeyCourseNumber,COU:Number)
                         PROJECT(CLA:RoomNumber)
                         PROJECT(CLA:ScheduledTime)
                         PROJECT(CLA:TeacherNumber)
                         PROJECT(CLA:ClassNumber)
                         JOIN(TEA:KeyTeacherNumber,CLA:TeacherNumber)
                           PROJECT(TEA:FirstName)
                           PROJECT(TEA:LastName)
                         END
                         JOIN(ENR:SeqStu,CLA:ClassNumber)
                           PROJECT(ENR:StudentNumber)
                           JOIN(STU:KeyStudentNumber,ENR:StudentNumber)
                             PROJECT(STU:FirstName)
                             PROJECT(STU:LastName)
                           END
                         END
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),DOUBLE,CENTER,GRAY,TIMER(1)
                       PROGRESS,AT(15,15,111,12),USE(Progress:Thermometer),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(1010,1417,6500,7438),PRE(Rpt),FONT('Arial',10,COLOR:Black),THOUS
                       HEADER,AT(990,1000,6500,406)
                         STRING('Attendance'),AT(2448,52),USE(?String17),FONT(,18,COLOR:Black,FONT:italic)
                       END
DescriptionBREAK       BREAK(COU:Description)
ClassBREAK               BREAK(CLA:ClassNumber)
                           HEADER,AT(0,0,,1594),FONT('Arial',10,COLOR:Black,FONT:bold)
                             STRING(@s40),AT(10,10),USE(COU:Description),FONT(,18,COLOR:Black)
                             GROUP('Class'),AT(1010,333,1594,760),BOXED
                               STRING(@n4),AT(1844,563),USE(CLA:RoomNumber)
                               STRING('Room'),AT(1156,563),USE(?String25)
                               STRING(@s20),AT(1156,802,1094),USE(CLA:ScheduledTime)
                             END
                             GROUP('Teacher'),AT(4458,333,1594,760),BOXED
                               STRING(@s20),AT(4521,802),USE(TEA:LastName)
                               STRING(@s20),AT(4521,563),USE(TEA:FirstName)
                             END
                             LINE,AT(1021,1479,5500,0)
                             STRING('Student Number'),AT(3531,1198)
                             STRING('Last Name'),AT(1063,1208),USE(?String15)
                             STRING('First Name'),AT(2188,1208),USE(?String16)
                           END
Detail1                    DETAIL,AT(,,,250),USE(?Detail1),FONT('Arial',8,COLOR:Black)
                             STRING(@P###-##-####P),AT(3656,21),USE(ENR:StudentNumber)
                             STRING(@S20),AT(2094,10),USE(STU:FirstName)
                             STRING(@s20),AT(1042,10,948),USE(STU:LastName)
                           END
                           FOOTER,AT(0,0,,240),PAGEAFTER(-1),WITHPRIOR(1)
                           END
                         END
                       END
                       FOOTER,AT(1000,8833,,583),FONT('Times New Roman',9,COLOR:Black,FONT:bold+FONT:italic)
                         STRING('Page '),AT(5833,292)
                         STRING(@n5),AT(6115,292),PAGENO
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                       ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('AttendanceSheets')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Courses.SetOpenRelated()
  Relate:Courses.Open                                      ! File Courses used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{PROP:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Courses, ?Progress:PctText, Progress:Thermometer, 3000)
  ThisReport.AddSortOrder(COU:KeyDescription)
  ThisReport.SetFilter('ENR:StudentNumber <<> 0')
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{PROP:Text} = ''
  Relate:Courses.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom = True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Courses.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(Rpt:Detail1)
  RETURN ReturnValue

