

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL024.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Report
!!! Student Schedules
!!! </summary>
ClassSchedules1 PROCEDURE 

RejectRecord         LONG                                  !
LocalRequest         LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
RecordsToProcess     LONG,AUTO                             !
RecordsProcessed     LONG,AUTO                             !
RecordsPerCycle      LONG,AUTO                             !
RecordsThisCycle     LONG,AUTO                             !
PercentProgress      BYTE                                  !
RecordStatus         BYTE,AUTO                             !
Progress:Thermometer BYTE                                  !
Process:View         VIEW(Enrollment)
                       PROJECT(ENR:ClassNumber)
                       PROJECT(ENR:StudentNumber)
                       JOIN(CLA:KeyClassNumber,ENR:ClassNumber)
                         PROJECT(CLA:RoomNumber)
                         PROJECT(CLA:ScheduledTime)
                         PROJECT(CLA:TeacherNumber)
                         PROJECT(CLA:CourseNumber)
                         JOIN(TEA:KeyTeacherNumber,CLA:TeacherNumber)
                         END
                         JOIN(COU:KeyNumber,CLA:CourseNumber)
                           PROJECT(COU:Description)
                         END
                       END
                       JOIN(STU:KeyStudentNumber,ENR:StudentNumber)
                         PROJECT(STU:FirstName)
                         PROJECT(STU:LastName)
                         PROJECT(STU:Number)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),DOUBLE,CENTER,GRAY,TIMER(1)
                       PROGRESS,AT(15,15,111,12),USE(Progress:Thermometer),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT,AT(1000,1552,6000,7448),PRE(RPT),FONT('Arial',10,COLOR:Black),THOUS
                       HEADER,AT(1000,1000,6000,552)
                         STRING('Student Schedule'),AT(0,281,6000,220),FONT(,,COLOR:Black,FONT:bold),CENTER
                       END
ENR:StudentNumberBreak BREAK(ENR:StudentNumber)
                         HEADER,AT(0,0,5990,677)
                           STRING(@P###-##-####P),AT(3406,63),USE(STU:Number),FONT(,,COLOR:Black,FONT:bold),RIGHT(1)
                           STRING('Room'),AT(2875,292),USE(?String9),FONT(,,COLOR:Black,FONT:bold)
                           STRING('Time'),AT(3688,292),USE(?String10),FONT(,,COLOR:Black,FONT:bold)
                           LINE,AT(50,560,5900,0),USE(?Line2),COLOR(COLOR:Black)
                           STRING('Class'),AT(479,292),USE(?String11),FONT(,,COLOR:Black,FONT:bold)
                           STRING(@S20),AT(83,63),USE(STU:FirstName),FONT(,,COLOR:Black,FONT:bold)
                           STRING(@S20),AT(1760,63),USE(STU:LastName),FONT(,,COLOR:Black,FONT:bold)
                         END
detail                   DETAIL,AT(-10,10,6000,302),USE(?detail)
                           STRING(@S30),AT(250,42),USE(COU:Description)
                           STRING(@n4),AT(2875,42),USE(CLA:RoomNumber)
                           STRING(@s20),AT(3688,42),USE(CLA:ScheduledTime)
                         END
                         FOOTER,AT(0,0,,323),PAGEAFTER(-1)
                         END
                       END
                       FOOTER,AT(1000,9000,6000,219)
                         STRING(@pPage <<<#p),AT(5250,30,700,135),USE(?PageCount),FONT('Arial',8,COLOR:Black,FONT:regular), |
  PAGENO
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                         ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('ClassSchedules1')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Enrollment.SetOpenRelated()
  Relate:Enrollment.Open                                   ! File Enrollment used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{PROP:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Enrollment, ?Progress:PctText, Progress:Thermometer, ProgressMgr, ENR:StudentNumber)
  ThisReport.AddSortOrder(ENR:StuSeq)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{PROP:Text} = ''
  Relate:Enrollment.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom = True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Enrollment.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

