

   MEMBER('SCHOOL.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('SCHOOL025.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Report
!!! </summary>
EnrollSummary PROCEDURE 

RejectRecord         LONG                                  !
LocalRequest         LONG                                  !
LocalResponse        LONG                                  !
FilesOpened          BYTE                                  !
WindowOpened         LONG                                  !
RecordsToProcess     LONG,AUTO                             !
RecordsProcessed     LONG,AUTO                             !
RecordsPerCycle      LONG,AUTO                             !
RecordsThisCycle     LONG,AUTO                             !
PercentProgress      BYTE                                  !
RecordStatus         BYTE,AUTO                             !
Cnt_StudentNumber    LONG                                  !
Cnt_StudentNumber_2  LONG                                  !
FinalGrade           DECIMAL(5,2)                          !
Progress:Thermometer BYTE                                  !
Process:View         VIEW(Courses)
                       PROJECT(COU:Description)
                       PROJECT(COU:Number)
                       JOIN(CLA:KeyCourseNumber,COU:Number)
                         PROJECT(CLA:RoomNumber)
                         PROJECT(CLA:ScheduledTime)
                         PROJECT(CLA:TeacherNumber)
                         PROJECT(CLA:ClassNumber)
                         JOIN(TEA:KeyTeacherNumber,CLA:TeacherNumber)
                           PROJECT(TEA:FirstName)
                           PROJECT(TEA:LastName)
                         END
                         JOIN(ENR:SeqStu,CLA:ClassNumber)
                         END
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),DOUBLE,CENTER,GRAY,TIMER(1)
                       PROGRESS,AT(15,15,111,12),USE(Progress:Thermometer),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(1000,1104,6500,7729),PRE(Rpt),FONT('Arial',10,COLOR:Black),THOUS
                       HEADER,AT(1000,490,6500,615)
                         STRING('Enrollment Summary Report'),AT(1760,250),USE(?String11),FONT(,18,COLOR:Black,FONT:italic)
                       END
DescriptionBREAK       BREAK(COU:Description)
                         HEADER,AT(0,0,,354),FONT('Arial',10,COLOR:Black,FONT:bold)
                           STRING(@s40),AT(0,0),USE(COU:Description),FONT(,18,COLOR:Black)
                         END
ClassBREAK               BREAK(CLA:ClassNumber)
                           HEADER,AT(0,0,,792),FONT('Arial',10,COLOR:Black,FONT:bold)
                             GROUP('Class'),AT(115,94,2146,552),BOXED
                               STRING(@n4),AT(604,313),USE(CLA:RoomNumber)
                               STRING('Room'),AT(156,313),USE(?String25)
                               STRING(@s20),AT(1031,313,1094),USE(CLA:ScheduledTime)
                             END
                             GROUP('Teacher'),AT(2510,125,3240,510),BOXED
                               STRING(@s20),AT(4125,313),USE(TEA:LastName)
                               STRING(@s20),AT(2573,313),USE(TEA:FirstName)
                             END
                           END
Detail1                    DETAIL,AT(,,,0),USE(?Detail1),FONT('Arial',8,COLOR:Black)
                           END
                           FOOTER,AT(0,0,,458),WITHPRIOR(1)
                             STRING(@n5),AT(156,125),USE(Cnt_StudentNumber_2),CNT,RESET(ClassBREAK)
                             STRING('Students Enrolled in this Class'),AT(708,125)
                           END
                         END
                         FOOTER,AT(0,0,,448),PAGEAFTER(-1),WITHPRIOR(1)
                           LINE,AT(63,63,3156,0),USE(?Line1),COLOR(COLOR:Black)
                           STRING(@n5),AT(156,104),USE(Cnt_StudentNumber),CNT,RESET(DescriptionBREAK)
                           STRING('Students Enrolled in this Course'),AT(708,104)
                         END
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)                   ! Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                       ! Progress Manager
Previewer            PrintPreviewClass                     ! Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('EnrollSummary')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Relate:Courses.SetOpenRelated()
  Relate:Courses.Open                                      ! File Courses used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(ProgressWindow)                                ! Open window
  Do DefineListboxStyle
  ProgressWindow{PROP:Timer} = 10                          ! Assign timer interval
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Courses, ?Progress:PctText, Progress:Thermometer, ProgressMgr, COU:Description)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(COU:KeyDescription)
  ThisReport.SetFilter('ENR:StudentNumber <<> 0')
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{PROP:Text} = ''
  Relate:Courses.SetQuickScan(1,Propagate:OneMany)
  SELF.SkipPreview = False
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom = True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Courses.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(Rpt:Detail1)
  RETURN ReturnValue

